#import <UIKit/UIKit.h>
#import <UIKit/UIApplication.h>

#import "MarblesApp.h"

@implementation MarblesApp

- (void)test;
{
    int x;
    x = 0;
}

#pragma mark UIApplication

- (void)applicationDidFinishLaunching:(NSNotification *)notification;
{
/*
	NOTE: If you think that doing something like this would be smarter:

	NSDate *startDate = [NSDate date];
	// ... work, work, work ...
	NSDate *endDate = [NSDate date];
	NSTimeInterval timeInterval = [endDate timeIntervalSinceDate:startDate];
	NSLog(@"Benchmark took %f seconds.", timeInterval);

	You'd be totally right. Until you try to link and find out that
	_objc_msgSend_fpret isn't defined in any of the runtime libraries.

	So get out your calculator...
*/
    NSLog(@"Started 1 at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]); {
        int i;
        int x = 0;
        for (i = 0; i < 100000; i++)
        {
            x = 0;
        }
    } NSLog(@"Benchmark 1 ended at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]);

    NSLog(@"Started 2 at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]); {
        int i;
        int x = 0;
        for (i = 1; i < 10001; i++)
        {
            x = 10000 / i;
        }
    } NSLog(@"Benchmark 2 ended at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]);
    
    NSLog(@"Started 3 at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]); {
        int i;
        int x = 0;
        for (i = 0; i < 10000; i++)
        {
            x = sinf((float)i);
        }
    } NSLog(@"Benchmark 3 ended at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]);
    
    NSLog(@"Started 4 at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]); {
        int i;
        NSString *x = nil;
        for (i = 0; i < 10000; i++)
        {
            x = [NSString string];
            unsigned int y = [x length];
        }
    } NSLog(@"Benchmark 4 ended at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]);
    
    NSLog(@"Started 5 at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]); {
        int i;
        for (i = 0; i < 10000; i++)
        {
            [self test];
        }
    } NSLog(@"Benchmark 5 ended at %@", [[NSDate date] valueForKey:@"timeIntervalSinceReferenceDate"]);

	exit(0);
}

@end
